<?php

namespace App\Factory;

use App\Exception;

class PaymentFactory {

    private $connection;

    public function __construct (\Doctrine\DBAL\Connection $connection) {
        $this->connection = $connection;
    }
    
    public function getReceiptType($receipt, $cdFilial) {
        //===================== Busca por filial =====================
        $sql = "
            SELECT CDTIPORECE
              
              FROM TIPORECEINTELOCAL TP
              
              JOIN INTEGRACAO INTE 
                ON TP.CDINTEGRACAO   = INTE.CDINTEGRACAO
             
             WHERE INTE.IDINTEGRACAO = 'DDI' 
               AND CDFILIAL          = :CDFILIAL
               AND UPPER(REPLACE(CDTPRECEINTE, ' ', '')) = :CDTPRECEINTE    
        ";

        $params = [
            ":CDFILIAL"     => $cdFilial,
            ":CDTPRECEINTE" => mb_strtoupper(preg_replace("/\s+/", "", $receipt))
        ];

        $result = $this->connection->fetchAll($sql, $params);
        
        if(!empty($result) && isset($result[0]["CDTIPORECE"])) 
            return $result[0]["CDTIPORECE"];
        
        //===================== Busca pela rede =====================

        $sql = "
            SELECT CDTIPORECE

              FROM TIPORECEINTE TP
            
              JOIN INTEGRACAO INTE 
                ON TP.CDINTEGRACAO   = INTE.CDINTEGRACAO

             WHERE INTE.IDINTEGRACAO = 'DDI' 
               AND UPPER(REPLACE(CDTPRECEINTE, ' ', '')) = :CDTPRECEINTE
        ";
        
        $params = [
            ":CDTPRECEINTE" => mb_strtoupper(preg_replace("/\s+/", "", $receipt))
        ];
        
        $result = $this->connection->fetchAll($sql, $params);

        if(empty($result) || !isset($result[0]["CDTIPORECE"])){
            throw new Exception\ParamsException("Não foi encontrado tipo de recebimento associado ao código: $receipt", 112);
        } else {
            return $result[0]["CDTIPORECE"];
        }
    }
    
    public function getMoneyReceiptCode () {
        $sql = "SELECT MIN(CDTIPORECE) AS CDTIPORECE
                FROM TIPORECE
                WHERE IDTIPORECE = '4'";
        
        $result = $this->connection->fetchAll($sql);
        
        return $result[0]["CDTIPORECE"];
    }
    
}
